
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SubscriptionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        billing_period: data.billing_period
        ||
        null
            ,
            
        price_amount: data.price_amount
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        current_period_start: data.current_period_start
        ||
        null
            ,
            
        current_period_end: data.current_period_end
        ||
        null
            ,
            
        canceled_at: data.canceled_at
        ||
        null
            ,
            
        payment_provider: data.payment_provider
        ||
        null
            ,
            
        provider_customer_ref: data.provider_customer_ref
        ||
        null
            ,
            
        provider_subscription_ref: data.provider_subscription_ref
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await subscriptions.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return subscriptions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const subscriptionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                billing_period: item.billing_period
            ||
            null
            ,
            
                price_amount: item.price_amount
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                current_period_start: item.current_period_start
            ||
            null
            ,
            
                current_period_end: item.current_period_end
            ||
            null
            ,
            
                canceled_at: item.canceled_at
            ||
            null
            ,
            
                payment_provider: item.payment_provider
            ||
            null
            ,
            
                provider_customer_ref: item.provider_customer_ref
            ||
            null
            ,
            
                provider_subscription_ref: item.provider_subscription_ref
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const subscriptions = await db.subscriptions.bulkCreate(subscriptionsData, { transaction });

        // For each item created, replace relation files
        

        return subscriptions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const subscriptions = await db.subscriptions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.billing_period !== undefined) updatePayload.billing_period = data.billing_period;
        
        
        if (data.price_amount !== undefined) updatePayload.price_amount = data.price_amount;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.current_period_start !== undefined) updatePayload.current_period_start = data.current_period_start;
        
        
        if (data.current_period_end !== undefined) updatePayload.current_period_end = data.current_period_end;
        
        
        if (data.canceled_at !== undefined) updatePayload.canceled_at = data.canceled_at;
        
        
        if (data.payment_provider !== undefined) updatePayload.payment_provider = data.payment_provider;
        
        
        if (data.provider_customer_ref !== undefined) updatePayload.provider_customer_ref = data.provider_customer_ref;
        
        
        if (data.provider_subscription_ref !== undefined) updatePayload.provider_subscription_ref = data.provider_subscription_ref;
        
        
        updatePayload.updatedById = currentUser.id;

        await subscriptions.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await subscriptions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return subscriptions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of subscriptions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of subscriptions) {
                await record.destroy({transaction});
            }
        });


        return subscriptions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findByPk(id, options);

        await subscriptions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await subscriptions.destroy({
            transaction
        });

        return subscriptions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const subscriptions = await db.subscriptions.findOne(
            { where },
            { transaction },
        );

        if (!subscriptions) {
            return subscriptions;
        }

        const output = subscriptions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await subscriptions.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subscriptions',
                        'currency',
                        filter.currency,
                    ),
                };
            }
            
            if (filter.payment_provider) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subscriptions',
                        'payment_provider',
                        filter.payment_provider,
                    ),
                };
            }
            
            if (filter.provider_customer_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subscriptions',
                        'provider_customer_ref',
                        filter.provider_customer_ref,
                    ),
                };
            }
            
            if (filter.provider_subscription_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subscriptions',
                        'provider_subscription_ref',
                        filter.provider_subscription_ref,
                    ),
                };
            }
            

            
            

            
            if (filter.price_amountRange) {
                const [start, end] = filter.price_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    price_amount: {
                    ...where.price_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    price_amount: {
                    ...where.price_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.current_period_startRange) {
                const [start, end] = filter.current_period_startRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_period_start: {
                    ...where.current_period_start,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_period_start: {
                    ...where.current_period_start,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.current_period_endRange) {
                const [start, end] = filter.current_period_endRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_period_end: {
                    ...where.current_period_end,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_period_end: {
                    ...where.current_period_end,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.canceled_atRange) {
                const [start, end] = filter.canceled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    canceled_at: {
                    ...where.canceled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    canceled_at: {
                    ...where.canceled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.billing_period) {
                where = {
                    ...where,
                billing_period: filter.billing_period,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.subscriptions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'subscriptions',
                        'provider_subscription_ref',
                        query,
                    ),
                ],
            };
        }

        const records = await db.subscriptions.findAll({
            attributes: [ 'id', 'provider_subscription_ref' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['provider_subscription_ref', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.provider_subscription_ref,
        }));
    }

    
};

